#include "list.h"

using namespace std;

// Konstruktor: ltrehozza a lncolt lista fejelemt s belltja a mutatkat.
List::List()
{
	header = new Node();
	last = header;
}

// Copy konstruktor: lemsolja az argumentumban megadott objektumot.
List::List(const List &ol)
{
	header = new Node(ol.header->value);
	last = header;
	
	Node *current = ol.header->next;
	while(current != NULL)
	{
		append(current->value);
		current = current->next;
	}
}

// Destruktor, a HEAP-en lefoglalt terlet felszabadtsa.
List::~List()
{
	Node *current;
	while(header != NULL)
	{
		current = header;
		header = header->next;
		delete current;
	}
}

// rtkads opertor: lemsolja az argumentumban megadott objektumot, ha nem sajt magt adtuk rtkl.
List &List::operator=(const List &ol)
{
	// Sajt magnak prbljuk-e rtkl adni?
	if(this == &ol)
		return *this;

	// Rgi lista megsemmistse.
	Node *current;
	while(header != NULL)
	{
		current = header;
		header = header->next;
		delete current;
	}

	// Paramter lista tmsolsa.
	header = new Node(ol.header->value);
	last = header;
	
	current = ol.header->next;
	while(current != NULL)
	{
		append(current->value);
		current = current->next;
	}
	
	return *this;
}

// Elem hozzfzse a lncolt lista vgre.
void List::append(const double &v)
{
	last->next = new Node(v);
	last = last->next;
}

// Elem befzse a lncolt lista elejre.
void List::prepend(const double &v)
{
	header->next = new Node(v, header->next);
}

// A lncolt listban trolt maximlis rtk megkeresse. Ha a lista res, akkor kivtel kivltsa.
double List::getMax() const throw(ListException)
{
	if(header->next == NULL)
		throw Empty;
	
	Node *max = header->next;
	Node *current = max->next;
	while(current != NULL)
	{
		if(current->value > max->value)
			max = current;
		current = current->next;
	}
	return max->value;
}

// Kir opertor megvalstsa, a lncolt lista elemeinek felsorolsa.
ostream &operator<<(ostream &out, const List &l)
{
	List::Node *current = l.header->next;
	while(current != NULL)
	{
		out << current->value << " ";
		current = current->next;
	}
	out << endl;
}
